routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Auth::routes();

Route::resource('users', \App\Http\Controllers\UserController::class)->only('index', 'show');

Route::resource('tasks', \App\Http\Controllers\TaskController::class)->except('create', 'index');

Route::resource('tags', \App\Http\Controllers\TagController::class)->except('show');
Route::get('/search/tag', [\App\Http\Controllers\TagController::class, 'search'])->name('tags.search');
Route::get('/tag_task/{task}', [\App\Http\Controllers\TagTaskController::class, 'index'])->name('tag_task.index');
Route::post('/tag_task', [\App\Http\Controllers\TagTaskController::class, 'store'])->name('tag_task.store');
Route::delete('/tag_task', [\App\Http\Controllers\TagTaskController::class, 'destroy'])->name('tag_task.destroy');


Route::get('/user_friend/read/{user}', [\App\Http\Controllers\UserFriendController::class, 'addReadFriend']);
Route::delete('/user_friend/read/{user}', [\App\Http\Controllers\UserFriendController::class, 'deleteReadFriend']);
Route::get('/user_friend/edit/{user}', [\App\Http\Controllers\UserFriendController::class, 'addEditFriend']);
Route::delete('/user_friend/edit/{user}', [\App\Http\Controllers\UserFriendController::class, 'deleteEditFriend']);

app/Http/Controllers/TagTaskController.php
<?php

namespace App\Http\Controllers;

use App\Models\Task;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class TagTaskController extends Controller
{

    public function __construct()
    {
        return $this->middleware('auth');
    }

    /**
     * @param Task $task
     * @return Factory|View|Application
     */
    public function index(Task $task): View|Factory|Application
    {
        $tags = Auth::user()->tags;
        return view('tag_task.index', compact('tags', 'task'));
    }

    /**
     * @param Request $request
     * @return RedirectResponse
     */
    public function store(Request $request): RedirectResponse
    {
        $task = Task::findOrFail($request->get('task'));
        $task->tags()->syncWithoutDetaching($request->get('tag'));

        return redirect()->back()->with('success', 'Successfully created!');
    }


    /**
     * @param Request $request
     * @return RedirectResponse
     */
    public function destroy(Request $request): RedirectResponse
    {
        $task = Task::findOrFail($request->get('task'));
        $task->tags()->detach($request->get('tag'));

        return redirect()->back()->with('success', 'Successfully deleted!');
    }

}

resources/views/tag_task/index.blade.php
@extends('layouts.app')
@section('content')
    <h3>Create new tag <a class="btn btn-outline-primary" href="{{ route('tags.create') }}">Create</a></h3>
    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">ID</th>
            <th scope="col">Tag</th>
            <th scope="col">Actions</th>
        </tr>
        </thead>
        <tbody id="tasks_list">
        @foreach($tags as $tag)
            <tr>
                <td>{{ $tag->id }}</td>
                <td class="w-50">{{ $tag->tag }}</td>
                <td class="d-flex">
                    @if($task->tags()->where('tag_id', $tag->id)->count() > 0)
                        <form method="post" action="{{ route('tag_task.destroy') }}">
                            @csrf
                            @method('DELETE')
                            <input name="task" type="hidden" value="{{ $task->id }}">
                            <input name="tag" type="hidden" value="{{ $tag->id }}">
                            <button type="submit" class="btn btn-danger">Delete</button>
                        </form>
                    @else
                        <form method="post" action="{{ route('tag_task.store') }}">
                            @csrf
                            <input name="task" type="hidden" value="{{ $task->id }}">
                            <input name="tag" type="hidden" value="{{ $tag->id }}">
                            <button type="submit" class="btn btn-info mx-1">Add</button>
                        </form>
                    @endif
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>
    <a href="{{ route('users.show', ['user' => Auth::user()]) }}" class="btn btn-outline-secondary">Back</a>
@endsection